set(0,'DefaultLineLineWidth',4);
clf;
% precios (ficticios) de cervezas, semanales durante 20 anyos
v=[0:1/52:20];
p=4.5*exp(0.02*v)+rand(size(v))/3+(0.1+abs(rand(size(v))/10)).*(sin(v*2*pi-pi/2.2));
% se sabe que la inflación es .5% anual
% y que hay una fluctuacion estacional (cara en verano,
%   barata en invierno)


% ahora se trata de encontrar un modelo del tipo
% p(t) = a + b*exp(0.02*t) + c*sin(2pi*t) + d*cos(2pi*t)
% donde t es el tiempo en anyos
% 
% la manera directa (no la mejor) de hacerlo es:
X=[ones(size(v));exp(0.02*v);sin(v*2*pi);cos(v*2*pi)];
A=X*X';
Y=X*p';
coefs=A\Y;
f = @(t) coefs(1)*ones(size(v)) + ...
    coefs(2)*exp(0.02*t)+ ...
    coefs(3)*sin(t*2*pi)+ ... 
    coefs(4)*cos(t*2*pi);

% plot prices
plot(v,p,'.','MarkerSize',15);
pause
hold on
plot(v, f(v),'r');
